SystemOrganization addCategory: #ConfigurationOfPenguins!

Object subclass: #ConfigurationOfPenguins
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPenguins'!

!ConfigurationOfPenguins class methodsFor: 'development support' stamp: 'pre 1/22/2013 17:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPenguins class methodsFor: 'private' stamp: 'pre 1/22/2013 17:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPenguins class methodsFor: 'private' stamp: 'pre 1/22/2013 17:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPenguins class methodsFor: 'private' stamp: 'pre 1/22/2013 17:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPenguins class methodsFor: 'metacello tool support' stamp: 'pre 1/22/2013 17:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPenguins class methodsFor: 'loading' stamp: 'pre 1/22/2013 17:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPenguins class methodsFor: 'loading' stamp: 'pre 1/22/2013 17:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPenguins class methodsFor: 'loading' stamp: 'pre 1/22/2013 17:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPenguins class methodsFor: 'accessing' stamp: 'pre 1/22/2013 17:40'!
project

	^self new project! !

!ConfigurationOfPenguins class methodsFor: 'development support' stamp: 'pre 1/22/2013 17:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPenguins methodsFor: 'baselines' stamp: 'pre 1/22/2013 17:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/modsysbinarymodules2/'.
		spec 
			package: 'Pgi'.
		spec group: 'default' with: #('Pgi' ). ].
! !

!ConfigurationOfPenguins methodsFor: 'symbolic versions' stamp: 'pre 1/22/2013 17:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfPenguins methodsFor: 'accessing' stamp: 'pre 1/22/2013 17:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPenguins methodsFor: 'accessing' stamp: 'pre 1/22/2013 17:40'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'squeak4.x' version: '1.0'.! !

!ConfigurationOfPenguins methodsFor: 'versions' stamp: 'pre 1/22/2013 20:24'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial development version'.
		spec author: 'pre'.
		spec timestamp: '12/12/2011 17:29'.
		spec 
			package: 'Pgi' with: 'Pgi-pre.238'. ].
! !
